/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of MersenneTwister.xs. Do not edit this file, edit MersenneTwister.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MersenneTwister.xs"
/* Filename: Rand/MersenneTwister.xs
 * Author:   George Schlossnagle <george@omniti.com>
 *           Theo Schlossnagle <jesus@omniti.com>
 * Created:  3rd October 2002
 * Version:  1.0.1
 *
 * Copyright (c) 2002 OmniTI Computer Consulting, Inc. All rights reserved.
 *   This program is free software; you can redistribute it and/or
 *   modify it under the same terms as Perl itself.
 *
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define GENERATOR generator *

#ifndef PERL_VERSION
#include "patchlevel.h"
#define PERL_REVISION   5
#define PERL_VERSION    PATCHLEVEL
#define PERL_SUBVERSION SUBVERSION
#endif

#if PERL_REVISION == 5 && (PERL_VERSION < 4 || (PERL_VERSION == 4 && PERL_SUBVERSION <= 75 ))

#    define PL_sv_undef         sv_undef
#    define PL_na               na
#    define PL_curcop           curcop
#    define PL_compiling        compiling

#endif

SV *sv_NULL ;

#include <time.h>
#include <sys/types.h>
#include <unistd.h>


#define omniti_uint32 unsigned int

#define MT_N (624)
#define N             MT_N                 /* length of state vector */
#define M             (397)                /* a period parameter */
#define K             (0x9908B0DFU)        /* a magic constant */
#define hiBit(u)      ((u) & 0x80000000U)  /* mask all but highest   bit of u */
#define loBit(u)      ((u) & 0x00000001U)  /* mask all but lowest    bit of u */
#define loBits(u)     ((u) & 0x7FFFFFFFU)  /* mask     the highest   bit of u */
#define mixBits(u, v) (hiBit(u)|loBits(v)) /* move hi bit of u to hi bit of v */


typedef struct _generator {
    omniti_uint32 state[MT_N+1];   /* state vector + 1 extra to not violate ANSI C */
    omniti_uint32 *next;    /* next random value is computed from here */
    int left;  /* can *next++ this many times before reloading */
} generator;

static generator *mt_init()
{
    generator *gen;
    gen = (generator *)malloc(sizeof(generator));
    gen->next = NULL;
    gen->left = -1;
    return gen;
}

static void mt_free(generator *gen) {
  if(gen)
    free(gen);
}

static void mt_seed(generator *gen, omniti_uint32 seed) 
{
    omniti_uint32 x = (seed | 1U) &  0xFFFFFFFFU;
    omniti_uint32 *s = gen->state;
    int j;

    for(gen->left = 0, *s++ = x, j = N; --j;
       *s++ = (x *= 69069U) & 0xFFFFFFFFU);
}

static omniti_uint32 mt_reload(generator *gen)
{
    omniti_uint32 *p0 = gen->state;
    omniti_uint32 *p2 = gen->state + 2;
    omniti_uint32 *pM = gen->state + M;
    omniti_uint32 s0, s1;
    int j;

    if(gen->left < -1) {
        mt_seed(gen, 4357U);
    }
    gen->left = N -1, gen->next = gen->state + 1;

    for (s0 = gen->state[0], s1 = gen->state[1], j = N - M +1; --j; s0 = s1, s1 = *p2++) 
        *p0++ = *pM++ ^ (mixBits(s0, s1) >> 1) ^ (loBit(s1) ? K : 0U);

    for (pM = gen->state, j = M; --j; s0 = s1, s1 = *p2++)
        *p0++ = *pM++ ^ (mixBits(s0, s1) >> 1) ^ (loBit(s1) ? K : 0U);

    s1 = gen->state[0], *p0 = *pM ^ (mixBits(s0, s1) >> 1) ^ (loBit(s1) ? K : 0U);
    s1 ^= (s1 >> 11);
    s1 ^= (s1 <<  7) & 0x9D2C5680U;
    s1 ^= (s1 << 15) & 0xEFC60000U;

    return s1 ^ (s1 >> 18);
}    


static omniti_uint32 mt_rand(generator *gen)
{
    omniti_uint32 y;

    if(--(gen->left) < 0) {
        return mt_reload(gen);
    }
    y = *(gen->next)++;
    y ^= (y >> 11);
    y ^= (y << 7) & 0x9D2C5680U;
    y ^= (y << 15) & 0xEFC60000U;

    return y ^ (y >> 18);
}

#define GENERATE_SEED() ((long) (time(0) * getpid() * 1000000))


static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static SV *
constant(name, arg)
char *name;
int arg;
{
    errno = ENOENT;
    return 0;
}

#line 157 "MersenneTwister.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 301 "MersenneTwister.c"

XS_EUPXS(XS_Rand__MersenneTwister_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Rand__MersenneTwister_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, arg");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	int	arg = (int)SvIV(ST(1))
;
	SV *	RETVAL;

	RETVAL = constant(name, arg);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Rand__MersenneTwister_mt_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Rand__MersenneTwister_mt_init)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 163 "MersenneTwister.xs"
        GENERATOR gen;
#line 333 "MersenneTwister.c"
	GENERATOR	RETVAL;
#line 165 "MersenneTwister.xs"
	  gen = mt_init();
          RETVAL = gen;
#line 338 "MersenneTwister.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "GENERATOR", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Rand__MersenneTwister_mt_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Rand__MersenneTwister_mt_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "gen");
    {
	GENERATOR	gen;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "GENERATOR")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    gen = INT2PTR(GENERATOR,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Rand::MersenneTwister::mt_free",
			"gen", "GENERATOR",
			refstr, ST(0)
		);
	}
;
#line 174 "MersenneTwister.xs"
          mt_free(gen);
          RETVAL = &PL_sv_yes;
#line 376 "MersenneTwister.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Rand__MersenneTwister_mt_seed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Rand__MersenneTwister_mt_seed)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "gen, seed");
    {
	GENERATOR	gen;
	SV *	seed = ST(1)
;
#line 184 "MersenneTwister.xs"
          int seedval;
#line 396 "MersenneTwister.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "GENERATOR")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    gen = INT2PTR(GENERATOR,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Rand::MersenneTwister::mt_seed",
			"gen", "GENERATOR",
			refstr, ST(0)
		);
	}
;
#line 186 "MersenneTwister.xs"
        {
          seedval = SvIV(seed);
	  mt_seed(gen, seedval);
	}
#line 416 "MersenneTwister.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Rand__MersenneTwister_mt_rand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Rand__MersenneTwister_mt_rand)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "gen, max=&PL_sv_undef");
    {
	GENERATOR	gen;
	SV *	max;
#line 197 "MersenneTwister.xs"
	omniti_uint32 v;
	double d;
#line 434 "MersenneTwister.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "GENERATOR")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    gen = INT2PTR(GENERATOR,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Rand::MersenneTwister::mt_rand",
			"gen", "GENERATOR",
			refstr, ST(0)
		);
	}
;

	if (items < 2)
	    max = &PL_sv_undef;
	else {
	    max = ST(1)
;
	}
#line 200 "MersenneTwister.xs"
	  if(max != &PL_sv_undef) {
	    d = SvNV(max);
	  } else {
	    d = 1.0;
	  }
	  v = mt_rand(gen);
	  d *= (double)v/(double)(UINT_MAX+1.0);
	  RETVAL = newSVnv(d);
#line 466 "MersenneTwister.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Rand__MersenneTwister); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Rand__MersenneTwister)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Rand::MersenneTwister::constant", XS_Rand__MersenneTwister_constant);
        newXS_deffile("Rand::MersenneTwister::mt_init", XS_Rand__MersenneTwister_mt_init);
        newXS_deffile("Rand::MersenneTwister::mt_free", XS_Rand__MersenneTwister_mt_free);
        newXS_deffile("Rand::MersenneTwister::mt_seed", XS_Rand__MersenneTwister_mt_seed);
        newXS_deffile("Rand::MersenneTwister::mt_rand", XS_Rand__MersenneTwister_mt_rand);

    /* Initialisation Section */

#line 153 "MersenneTwister.xs"
	sv_NULL = newSVpv("", 0) ;

#line 512 "MersenneTwister.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
